<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'track' => 'Track',
            'trackRequest' => 'TrackRequest',
            'credential' => 'Credential',
            'trackResponse' => 'TrackResponse',
            'trackResponseType' => 'TrackResponseType',
            'status' => 'Status',
            'trackConsignmentResponse' => 'TrackConsignmentResponse',
            'trackParcelResponse' => 'TrackParcelResponse',
            'trackParcelActivity' => 'TrackParcelActivity',
            'getCost' => 'GetCost',
            'costRequest' => 'CostRequest',
            'getCostResponse' => 'GetCostResponse',
            'costResponseType' => 'CostResponseType',
            'costResponse' => 'CostResponse',
            'costPosition' => 'CostPosition',
            'bills' => 'Bills',
            'billRequest' => 'BillRequest',
            'billsResponse' => 'BillsResponse',
            'billResponseType' => 'BillResponseType',
            'bill' => 'Bill',
            'billEntry' => 'BillEntry',
            'manifest' => 'Manifest',
            'manifestRequest' => 'ManifestRequest',
            'manifestResponse' => 'ManifestResponse',
            'manifestResponseType' => 'ManifestResponseType',
            'book' => 'Book',
            'bookRequest' => 'BookRequest',
            'consignment' => 'Consignment',
            'party' => 'Party',
            'information' => 'Information',
            'parcel' => 'Parcel',
            'bookResponse' => 'BookResponse',
            'bookResponseType' => 'BookResponseType',
            'consignmentResponse' => 'ConsignmentResponse',
            'parcelResponse' => 'ParcelResponse',
            'rates' => 'Rates',
            'rateRequest' => 'RateRequest',
            'ratesResponse' => 'RatesResponse',
            'rateResponseType' => 'RateResponseType',
            'rateConsignmentResponse' => 'RateConsignmentResponse',
            'rateInformation' => 'RateInformation',
            'getLabels' => 'GetLabels',
            'labelsRequest' => 'LabelsRequest',
            'getLabelsResponse' => 'GetLabelsResponse',
            'labelsResponseType' => 'LabelsResponseType',
            'labelsResponse' => 'LabelsResponse',
            'cancel' => 'Cancel',
            'cancelRequest' => 'CancelRequest',
            'cancelConsignment' => 'CancelConsignment',
            'cancelResponse' => 'CancelResponse',
            'cancelResponseType' => 'CancelResponseType',
            'printLabels' => 'PrintLabels',
            'printLabelsRequest' => 'PrintLabelsRequest',
            'printLabelsResponse' => 'PrintLabelsResponse',
            'printLabelsResponseType' => 'PrintLabelsResponseType',
        );
    }
}
