<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for manifest Structure
 * Meta information extracted from the WSDL
 * - type: tns:manifest
 * @subpackage Structs
 */
class Manifest extends AbstractStructBase
{
    /**
     * The ManifestRequestType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var ManifestRequest
     */
    public $ManifestRequestType;
    /**
     * Constructor method for manifest
     * @uses Manifest::setManifestRequestType()
     * @param ManifestRequest $manifestRequestType
     */
    public function __construct(ManifestRequest $manifestRequestType = null)
    {
        $this
            ->setManifestRequestType($manifestRequestType);
    }
    /**
     * Get ManifestRequestType value
     * @return ManifestRequest|null
     */
    public function getManifestRequestType()
    {
        return $this->ManifestRequestType;
    }
    /**
     * Set ManifestRequestType value
     * @param ManifestRequest $manifestRequestType
     * @return Manifest
     */
    public function setManifestRequestType(ManifestRequest $manifestRequestType = null)
    {
        $this->ManifestRequestType = $manifestRequestType;
        return $this;
    }
}
