<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for party Structure
 * @subpackage Structs
 */
class Party extends AbstractStructBase
{
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The name2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name2;
    /**
     * The street
     * @var string
     */
    public $street;
    /**
     * The street2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $street2;
    /**
     * The postalcode
     * @var string
     */
    public $postalcode;
    /**
     * The city
     * @var string
     */
    public $city;
    /**
     * The state
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $state;
    /**
     * The country
     * @var string
     */
    public $country;
    /**
     * The privateAddress
     * @var bool
     */
    public $privateAddress;
    /**
     * The exhibition
     * @var bool
     */
    public $exhibition;
    /**
     * The exhibitionHall
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $exhibitionHall;
    /**
     * The exhibitionBooth
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $exhibitionBooth;
    /**
     * Constructor method for party
     * @uses Party::setName()
     * @uses Party::setName2()
     * @uses Party::setStreet()
     * @uses Party::setStreet2()
     * @uses Party::setPostalcode()
     * @uses Party::setCity()
     * @uses Party::setState()
     * @uses Party::setCountry()
     * @uses Party::setPrivateAddress()
     * @uses Party::setExhibition()
     * @uses Party::setExhibitionHall()
     * @uses Party::setExhibitionBooth()
     * @param string $name
     * @param string $name2
     * @param string $street
     * @param string $street2
     * @param string $postalcode
     * @param string $city
     * @param string $state
     * @param string $country
     * @param bool $privateAddress
     * @param bool $exhibition
     * @param string $exhibitionHall
     * @param string $exhibitionBooth
     */
    public function __construct($name = null, $name2 = null, $street = null, $street2 = null, $postalcode = null, $city = null, $state = null, $country = null, $privateAddress = null, $exhibition = null, $exhibitionHall = null, $exhibitionBooth = null)
    {
        $this
            ->setName($name)
            ->setName2($name2)
            ->setStreet($street)
            ->setStreet2($street2)
            ->setPostalcode($postalcode)
            ->setCity($city)
            ->setState($state)
            ->setCountry($country)
            ->setPrivateAddress($privateAddress)
            ->setExhibition($exhibition)
            ->setExhibitionHall($exhibitionHall)
            ->setExhibitionBooth($exhibitionBooth);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return Party
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get name2 value
     * @return string|null
     */
    public function getName2()
    {
        return $this->name2;
    }
    /**
     * Set name2 value
     * @param string $name2
     * @return Party
     */
    public function setName2($name2 = null)
    {
        // validation for constraint: string
        if (!is_null($name2) && !is_string($name2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name2, true), gettype($name2)), __LINE__);
        }
        $this->name2 = $name2;
        return $this;
    }
    /**
     * Get street value
     * @return string|null
     */
    public function getStreet()
    {
        return $this->street;
    }
    /**
     * Set street value
     * @param string $street
     * @return Party
     */
    public function setStreet($street = null)
    {
        // validation for constraint: string
        if (!is_null($street) && !is_string($street)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($street, true), gettype($street)), __LINE__);
        }
        $this->street = $street;
        return $this;
    }
    /**
     * Get street2 value
     * @return string|null
     */
    public function getStreet2()
    {
        return $this->street2;
    }
    /**
     * Set street2 value
     * @param string $street2
     * @return Party
     */
    public function setStreet2($street2 = null)
    {
        // validation for constraint: string
        if (!is_null($street2) && !is_string($street2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($street2, true), gettype($street2)), __LINE__);
        }
        $this->street2 = $street2;
        return $this;
    }
    /**
     * Get postalcode value
     * @return string|null
     */
    public function getPostalcode()
    {
        return $this->postalcode;
    }
    /**
     * Set postalcode value
     * @param string $postalcode
     * @return Party
     */
    public function setPostalcode($postalcode = null)
    {
        // validation for constraint: string
        if (!is_null($postalcode) && !is_string($postalcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postalcode, true), gettype($postalcode)), __LINE__);
        }
        $this->postalcode = $postalcode;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return Party
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get state value
     * @return string|null
     */
    public function getState()
    {
        return $this->state;
    }
    /**
     * Set state value
     * @param string $state
     * @return Party
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        $this->state = $state;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return Party
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get privateAddress value
     * @return bool|null
     */
    public function getPrivateAddress()
    {
        return $this->privateAddress;
    }
    /**
     * Set privateAddress value
     * @param bool $privateAddress
     * @return Party
     */
    public function setPrivateAddress($privateAddress = null)
    {
        // validation for constraint: boolean
        if (!is_null($privateAddress) && !is_bool($privateAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($privateAddress, true), gettype($privateAddress)), __LINE__);
        }
        $this->privateAddress = $privateAddress;
        return $this;
    }
    /**
     * Get exhibition value
     * @return bool|null
     */
    public function getExhibition()
    {
        return $this->exhibition;
    }
    /**
     * Set exhibition value
     * @param bool $exhibition
     * @return Party
     */
    public function setExhibition($exhibition = null)
    {
        // validation for constraint: boolean
        if (!is_null($exhibition) && !is_bool($exhibition)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($exhibition, true), gettype($exhibition)), __LINE__);
        }
        $this->exhibition = $exhibition;
        return $this;
    }
    /**
     * Get exhibitionHall value
     * @return string|null
     */
    public function getExhibitionHall()
    {
        return $this->exhibitionHall;
    }
    /**
     * Set exhibitionHall value
     * @param string $exhibitionHall
     * @return Party
     */
    public function setExhibitionHall($exhibitionHall = null)
    {
        // validation for constraint: string
        if (!is_null($exhibitionHall) && !is_string($exhibitionHall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($exhibitionHall, true), gettype($exhibitionHall)), __LINE__);
        }
        $this->exhibitionHall = $exhibitionHall;
        return $this;
    }
    /**
     * Get exhibitionBooth value
     * @return string|null
     */
    public function getExhibitionBooth()
    {
        return $this->exhibitionBooth;
    }
    /**
     * Set exhibitionBooth value
     * @param string $exhibitionBooth
     * @return Party
     */
    public function setExhibitionBooth($exhibitionBooth = null)
    {
        // validation for constraint: string
        if (!is_null($exhibitionBooth) && !is_string($exhibitionBooth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($exhibitionBooth, true), gettype($exhibitionBooth)), __LINE__);
        }
        $this->exhibitionBooth = $exhibitionBooth;
        return $this;
    }
}
